
// Create by davidgf.net
// It's very basic no error control tool
// For the Sonic GBA demo I did


#include <iostream>
#include <string.h>
#include <sstream>

using namespace std;

#include "SDL/SDL.h"

#include "auxiliar.h"

const int SCREEN_WIDTH = 800;
const int SCREEN_HEIGHT = 600;
const int BAR_WIDTH = 180;
const int SCREEN_BPP = 32;
const int NUM_IMS = 19;

const int TILESW = 18;
const int TILESH = 18;

bool clicked = false;
int delay = 50;
int move = 50;

SDL_Surface *screen = NULL;
SDL_Surface *ims[NUM_IMS+1];
SDL_Surface *arrows[4];
SDL_Surface *background = NULL;
SDL_Surface *save = NULL;

SDL_Cursor * cursor;

int iexit = 0;
int width, height;
int x = 0, y = 0;
int selection = 0;

unsigned char *barray = NULL;


string global_filename;

void ClearScreen () {
	SDL_Rect rect;
	rect.x = 0;
	rect.y = 0;
	rect.w = SCREEN_WIDTH;
	rect.h = SCREEN_HEIGHT;
	SDL_FillRect(screen,&rect,0x000000);
}

void RenderPanel() {
	SDL_Rect rect;
	rect.x = SCREEN_WIDTH - BAR_WIDTH ;
	rect.y = 0;
	rect.w = BAR_WIDTH + 8;
	rect.h = SCREEN_HEIGHT;
	SDL_FillRect(screen,&rect,0x111111);

	for (int i = 0; i < NUM_IMS; i=i+5) {
		for (int j = 0; j <= (NUM_IMS-i) and j < 5; j++) {
			SDL_Rect dest;
			dest.y = 14 + 36 * (i/5);
			dest.x = SCREEN_WIDTH - BAR_WIDTH + 36 * j + 2;
			dest.h = 32; dest.w = 32;
			SDL_BlitSurface (ims[j+i],NULL,screen,&dest);
		}
	}

	SDL_Rect dest;
	dest.h = 32; dest.w = 32;

	dest.y = 400;
	dest.x = SCREEN_WIDTH - BAR_WIDTH + 80;
	SDL_BlitSurface (arrows[0],NULL,screen,&dest);

	dest.y = 464;
	SDL_BlitSurface (arrows[1],NULL,screen,&dest);

	dest.y = 432;
	dest.x = SCREEN_WIDTH - BAR_WIDTH + 48;
	SDL_BlitSurface (arrows[2],NULL,screen,&dest);

	dest.x = SCREEN_WIDTH - BAR_WIDTH + 112;
	SDL_BlitSurface (arrows[3],NULL,screen,&dest);

	dest.x = SCREEN_WIDTH - BAR_WIDTH + 80;
	SDL_BlitSurface (save,NULL,screen,&dest);

	dest.y = 300;
	SDL_BlitSurface (ims[selection],NULL,screen,&dest);
}

void RenderMap () {
	SDL_Rect rect;
	rect.x = 4;
	rect.y = 8;
	rect.w = SCREEN_WIDTH - BAR_WIDTH - 8;
	rect.h = SCREEN_HEIGHT - 16;
	SDL_FillRect(screen,&rect,0x333333);

	SDL_Rect origin,dest;
	origin.x = 32 * x; origin.y = 32 * y;
	origin.w = SCREEN_WIDTH - BAR_WIDTH - 8; origin.h  = SCREEN_HEIGHT - 16;
	dest.x = 4; dest.y = 8;
	SDL_BlitSurface (background,&origin,screen,&dest);

	for (int i = x; i < (x+TILESW); i++) {
		for (int j = y; j < (y+TILESH); j++) {
			SDL_Rect dest;
			dest.x = 4 + (i-x) * 32;
			dest.y = 8 + (j-y) * 32;
			dest.h = 32; dest.w = 32;
			if (j < height and i < width) 
			SDL_BlitSurface (ims[barray[j*width+i]],NULL,screen,&dest);
		}
	}
}

void Render() {
	ClearScreen();
	
	RenderPanel();
	RenderMap();

	if (move < 0) delay = 100;
	else delay = 10;
	SDL_Delay(delay);
	move--;
}

void LoadImages () {
	for (int i = 0; i <= NUM_IMS; i++) {
		string image = "./images/" + IntToStr(i) + ".bmp";
		ims[i] = SDL_LoadBMP(image.c_str());
		SDL_SetColorKey(ims[i],SDL_SRCCOLORKEY,0x000000);
	}
	arrows[0] = SDL_LoadBMP("./images/up.bmp");
	arrows[1] = SDL_LoadBMP("./images/down.bmp");
	arrows[2] = SDL_LoadBMP("./images/left.bmp");
	arrows[3] = SDL_LoadBMP("./images/right.bmp");
	save = SDL_LoadBMP("./images/save.bmp");
}

void clearevents(void) {
	SDL_Event event;
	SDL_Delay(100);
	while(SDL_PollEvent(&event)) SDL_Delay(20);
}

void ProcessClick (int mx, int my) {
	if (my > 400 and my < 432 and mx > SCREEN_WIDTH - BAR_WIDTH + 80 and mx < SCREEN_WIDTH - BAR_WIDTH + 112) {
		y = y - 1;
		if (y < 0) y = 0;
	}
	if (my > 464 and my < 496 and mx > SCREEN_WIDTH - BAR_WIDTH + 80 and mx < SCREEN_WIDTH - BAR_WIDTH + 112) {
		y = y + 1;
		if (height - y <= TILESH) y = height - TILESH;
	}
	if (my > 432 and my < 464 and mx > SCREEN_WIDTH - BAR_WIDTH + 48 and mx < SCREEN_WIDTH - BAR_WIDTH + 96) {
		x = x - 1;
		if (x < 0) x = 0;
	}
	if (my > 432 and my < 464 and mx > SCREEN_WIDTH - BAR_WIDTH + 112 and mx < SCREEN_WIDTH - BAR_WIDTH + 144) {
		x = x + 1;
		if (width - x <= TILESW) x = width - TILESW;
	}
	if (my > 432 and my < 464 and mx > SCREEN_WIDTH - BAR_WIDTH + 80 and mx < SCREEN_WIDTH - BAR_WIDTH + 112) {
		FILE * pFile = fopen (&global_filename[0],"w");
		fwrite(barray,1,width*height,pFile);
		fclose(pFile);
	}

	for (int i = 0; i < NUM_IMS; i=i+5) {
		for (int j = 0; j < 5; j++) {
			if (my > 14 + 36 * (i/5) and my < 14 + 32 + 36 * (i/5) and mx > SCREEN_WIDTH - BAR_WIDTH + 36 * j + 2 and mx < SCREEN_WIDTH - BAR_WIDTH + 36 * j + 2 +32) {
				selection = i+j;
			}
		}
	}

	for (int i = x; i < (x+TILESW); i++) {
		for (int j = y; j < (y+TILESH); j++) {
			if (mx > 4 + (i-x) * 32 and mx < 4 + 32 + (i-x) * 32 and my > 8 + (j-y) * 32 and my < 32 + 8 + (j-y) * 32) {
				if (j < height and i < width) {
					barray[j*width+i] = selection;
				}
			}
		}
	}


}

void GetEvents(void) {
	SDL_Event event;
	
	while(SDL_PollEvent(&event)) {
		switch(event.type) {
			case SDL_MOUSEMOTION:
				move = 50;
				if (clicked) ProcessClick (event.motion.x,event.motion.y);
				break;
			case SDL_MOUSEBUTTONDOWN:
				clicked = true;
				break;
			case SDL_MOUSEBUTTONUP:
				clicked = false;
				ProcessClick (event.motion.x,event.motion.y);
				break;
			case SDL_KEY:
				if (event.key.keysym.sym == SDLK_ESCAPE) {iexit = 1;}
				if (event.key.keysym.sym == SDLK_LEFT) {x = x - 1;if (x < 0) x = 0;}
				if (event.key.keysym.sym == SDLK_RIGHT) {x = x + 1;if (width - x <= TILESW) x = width - TILESW;}

				if (event.key.keysym.sym == SDLK_UP) {y = y - 1;if (y < 0) y = 0;}
				if (event.key.keysym.sym == SDLK_DOWN) {y = y + 1;if (height - y <= TILESH) y = height - TILESH;}

				break;
		}
	}
}

void MainLoop() {
	while (iexit == 0) {
		GetEvents();
		Render();
		SDL_Flip(screen);
	}
}

int main (int argc, const char *argv[]) {
	if (argc != 5) {cout << "USAGE: open/create width height filename" << endl; return 0;}

	string option(argv[1]), file(argv[4]);
	global_filename = file;
	int w,h;
	w = atoi(argv[2]); h = atoi(argv[3]);
	if (option == "create") {
		FILE * pFile = fopen (&file[0],"w");
		unsigned char b = 0;
		for (int i = 0; i < (w * h); i++) fwrite(&b,1,1,pFile);
		return 0;
	}
	if (option == "open") {
		FILE * pFile = fopen (&file[0],"rb");
		width = w; height = h;
		barray = (unsigned char *)malloc(w*h);
		fread(barray,1,w*h,pFile);
	}


	if (SDL_Init (SDL_INIT_VIDEO | SDL_INIT_JOYSTICK) < 0) {
		cout << "Error initalizing SDL: " << SDL_GetError() << endl;
		return 0;
	}

	screen = SDL_SetVideoMode(SCREEN_WIDTH,SCREEN_HEIGHT,SCREEN_BPP,SDL_HWSURFACE);
	if (screen == NULL) screen = SDL_SetVideoMode(SCREEN_WIDTH,SCREEN_HEIGHT,SCREEN_BPP,SDL_SWSURFACE);
	if (screen == NULL) {cout << "Error initializing video" << endl; SDL_Quit(); return 0;}

	SDL_WM_SetCaption("Level Editor", NULL);
	LoadImages();

	string bgfile(file);
	while (bgfile[bgfile.size()-1] != '.') bgfile.resize(bgfile.size()-1);
	bgfile += "bmp";
	background = SDL_LoadBMP(bgfile.c_str());
	SDL_SetColorKey(background,SDL_SRCCOLORKEY,0x0000ff);

	SDL_JoystickEventState(SDL_ENABLE);
	SDL_JoystickOpen(0);
	clearevents();

	MainLoop();
	
	free (barray);
	SDL_Quit();
	return 0;
}


